src/Entity/Platform.php
<?php

namespace App\Entity;

use App\Repository\PlatformRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PlatformRepository::class)
 */
class Platform
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $name_plat;

    /**
     * @ORM\Column(type="text")
     */
    private $description_plat;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $logo_plat;

    /**
     * @ORM\ManyToMany(targetEntity=Game::class, mappedBy="platform")
     */
    private $game;

    /**
     * @ORM\ManyToMany(targetEntity=UserHasGame::class, mappedBy="platform")
     */
    private $user_has_game;

    public function __construct()
    {
        $this->game = new ArrayCollection();
        $this->user_has_game = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNamePlat(): ?string
    {
        return $this->name_plat;
    }

    public function setNamePlat(string $name_plat): self
    {
        $this->name_plat = $name_plat;

        return $this;
    }

    public function getDescriptionPlat(): ?string
    {
        return $this->description_plat;
    }

    public function setDescriptionPlat(string $description_plat): self
    {
        $this->description_plat = $description_plat;

        return $this;
    }

    public function getLogoPlat(): ?string
    {
        return $this->logo_plat;
    }

    public function setLogoPlat(?string $logo_plat): self
    {
        $this->logo_plat = $logo_plat;

        return $this;
    }

    /**
     * @return Collection|Game[]
     */
    public function getGame(): Collection
    {
        return $this->game;
    }

    public function addGame(Game $game): self
    {
        if (!$this->game->contains($game)) {
            $this->game[] = $game;
            $game->addPlatform($this);
        }

        return $this;
    }

    public function removeGame(Game $game): self
    {
        if ($this->game->removeElement($game)) {
            $game->removePlatform($this);
        }

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasGame(): Collection
    {
        return $this->user_has_game;
    }

    public function addUserHasGame(userhasgame $userHasGame): self
    {
        if (!$this->user_has_game->contains($userHasGame)) {
            $this->user_has_game[] = $userHasGame;
        }

        return $this;
    }

    public function removeUserHasGame(userhasgame $userHasGame): self
    {
        $this->user_has_game->removeElement($userHasGame);

        return $this;
    }
}

src/Form/PlatformType.php
<?php

namespace App\Form;

use App\Entity\Platform;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class PlatformType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name_plat')
            ->add('description_plat')
            ->add('logo_plat', FileType::class, [
                'mapped' => false,
                'required' => false,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Platform::class,
        ]);
    }
}

src/Controller/PlatformController.php
<?php

namespace App\Controller;

use App\Entity\Platform;
use App\Form\PlatformType;
use App\Repository\PlatformRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\String\Slugger\SluggerInterface;

/**
 * @Route("/admin/platform")
 */
class PlatformController extends AbstractController
{
    /**
     * @Route("/", name="platform_index", methods={"GET"})
     */
    public function index(PlatformRepository $platformRepository): Response
    {
        return $this->render('platform/index.html.twig', [
            'platforms' => $platformRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="platform_new", methods={"GET","POST"})
     */
    public function new(Request $request, SluggerInterface $slugger): Response
    {
        $platform = new Platform();
        $form = $this->createForm(PlatformType::class, $platform);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $logoPlatFile = $form->get('logo_plat')->getData();

            // this condition is needed because the 'brochure' field is not required
            // so the PDF file must be processed only when a file is uploaded
            if ($logoPlatFile) {
                $originalFilename = pathinfo($logoPlatFile->getClientOriginalName(), PATHINFO_FILENAME);
                // this is needed to safely include the file name as part of the URL
                $safeFilename = $slugger->slug($originalFilename);
                $newFilename = $safeFilename . '-' . uniqid() . '.' . $logoPlatFile->guessExtension();

                // Move the file to the directory where brochures are stored
                try {
                    $logoPlatFile->move(
                        $this->getParameter('image_directory'),
                        $newFilename
                    );
                } catch (FileException $e) {
                    // ... handle exception if something happens during file upload
                }

                // updates the 'brochureFilename' property to store the PDF file name
                // instead of its contents
                $platform->setLogoPlat($newFilename);
            }

            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($platform);
            $entityManager->flush();

            return $this->redirectToRoute('platform_index');
        }

        return $this->render('platform/new.html.twig', [
            'platform' => $platform,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="platform_show", methods={"GET"})
     */
    public function show(Platform $platform): Response
    {
        return $this->render('platform/show.html.twig', [
            'platform' => $platform,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="platform_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Platform $platform): Response
    {
        $form = $this->createForm(PlatformType::class, $platform);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('platform_index');
        }

        return $this->render('platform/edit.html.twig', [
            'platform' => $platform,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="platform_delete", methods={"POST"})
     */
    public function delete(Request $request, Platform $platform): Response
    {
        if ($this->isCsrfTokenValid('delete'.$platform->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($platform);
            $entityManager->flush();
        }

        return $this->redirectToRoute('platform_index');
    }
}

templates/platform/_delete_form.html.twig
<form method="post" action="{{ path('platform_delete', {'id': platform.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ platform.id) }}">
    <button class="btn">Delete</button>
</form>

templates/platform/_form.html.twig
<div class="mdl-grid mdl-cell mdl-cell--12-col-desktop mdl-cell--12-col-tablet mdl-cell--4-col-phone mdl-cell--top">

    <div class="mdl-cell mdl-cell--7-col-desktop mdl-cell--7-col-tablet mdl-cell--4-col-phone">
        <div class="mdl-card mdl-shadow--2dp">
            <div class="mdl-card__title">
                <h5 class="mdl-card__title-text text-color--white">Create new Platform</h5>
            </div>

            <div class="mdl-card__supporting-text">

                {{ form_start(form) }}

                <div class="mdl-cell mdl-cell--6-col-desktop mdl-cell--6-col-tablet mdl-cell--4-col-phone form__article">
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.name_plat, { 'attr': {'class': 'mdl-textfield__input' , 'name': 'floating-first-name'} }) }}
                        <label class="mdl-textfield__label" for="floating-first-name">Platform name</label>
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.description_plat, { 'attr': {'class': 'mdl-textfield__input', 'name': 'floating-first-name'} }) }}
                        <label class="mdl-textfield__label" for="floating-last-name">Description</label>
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.logo_plat, { 'attr': {'class': 'mdl-textfield__input', 'name': 'floating-image'} }) }}
                    </div>
                    <button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect button--colored-light-blue">
                        {{ button_label|default('Save') }}
                    </button>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        <a href="{{ path('platform_index') }}">back to list</a>
                    </div>
                </div>

                {{ form_end(form) }}

            </div>

        </div>
    </div>
</div>

templates/platform/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Platform{% endblock %}

{% block body %}
    <h1>Edit Platform</h1>

    {{ include('platform/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('platform_index') }}">back to list</a>

    {{ include('platform/_delete_form.html.twig') }}
{% endblock %}

templates/platform/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Platform index{% endblock %}

{% block body %}

    {#<table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Name_plat</th>
                <th>Description_plat</th>
                <th>Logo_plat</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for platform in platforms %}
            <tr>
                <td>{{ platform.id }}</td>
                <td>{{ platform.namePlat }}</td>
                <td>{{ platform.descriptionPlat }}</td>
                <td><img class="logoPlatform" src="../uploads/image/{{ platform.logoPlat }}" alt=""></td>
                <td>
                    <a href="{{ path('platform_show', {'id': platform.id}) }}">show</a>
                    <a href="{{ path('platform_edit', {'id': platform.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>#}

    <div class="mdl-cell mdl-cell--12-col-desktop mdl-cell--12-col-tablet mdl-cell--4-col-phone scroll-tab">
        <div class="mdl-card mdl-shadow--2dp">
            <div class="mdl-card__title">
                <h1 class="mdl-card__title-text">Platform</h1>
            </div>
            <div class="mdl-card__supporting-text no-padding">
                <table class="mdl-data-table mdl-js-data-table">
                    <thead>
                    <tr>
                        <th class="mdl-data-table__cell--non-numeric">Id</th>
                        <th class="mdl-data-table__cell--non-numeric">Name_plat</th>
                        <th class="mdl-data-table__cell--non-numeric">Description_plat</th>
                        <th class="mdl-data-table__cell--non-numeric">Logo_plat</th>
                        <th class="mdl-data-table__cell--non-numeric">actions</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for platform in platforms %}
                        <tr>
                            <td class="mdl-data-table__cell--non-numeric">{{ platform.id }}</td>
                            <td class="mdl-data-table__cell--non-numeric">{{ platform.namePlat }}</td>
                            <td class="mdl-data-table__cell--non-numeric">{{ platform.descriptionPlat }}</td>
                            <td class="mdl-data-table__cell--non-numeric"><img class="logoPlatform" src="../uploads/image/{{ platform.logoPlat }}" alt=""></td>
                            <td class="mdl-data-table__cell--non-numeric">
                                <a href="{{ path('platform_show', {'id': platform.id}) }}">show</a>
                                <a href="{{ path('platform_edit', {'id': platform.id}) }}">edit</a>
                            </td>
                        </tr>
                    {% else %}
                        <tr>
                            <td colspan="7">no records found</td>
                        </tr>
                    {% endfor %}
                    <tr>
                        <td colspan="0"> <a href="{{ path('platform_new') }}">Create new</a></td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
{% endblock %}

templates/platform/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Platform{% endblock %}

{% block body %}

    {{ include('platform/_form.html.twig') }}

{% endblock %}

templates/platform/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Platform{% endblock %}

{% block body %}
    <h1>Platform</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ platform.id }}</td>
            </tr>
            <tr>
                <th>Name_plat</th>
                <td>{{ platform.namePlat }}</td>
            </tr>
            <tr>
                <th>Description_plat</th>
                <td>{{ platform.descriptionPlat }}</td>
            </tr>
            <tr>
                <th>Logo_plat</th>
                <td>{{ platform.logoPlat }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('platform_index') }}">back to list</a>

    <a href="{{ path('platform_edit', {'id': platform.id}) }}">edit</a>

    {{ include('platform/_delete_form.html.twig') }}
{% endblock %}